<?php

/*
// Calcul des nouvelles cotes de P1 et P2
// score = 1 si P1 gagne
// score = 0 si P1 perd
// score = 0.5 s'il y a match nul
*/

 
//************** FONCTIONS ****************//
 
// Calcul de la probabilité de gagner du joueur P1
function estimation($elo_1, $elo_2)
{
	$exp = ($elo_2 - $elo_1) / 400;
	return 1/ (1 + pow(10,$exp));
}
 
// Calcul de la nouvelle cote de P1
function calcul_elo($elo_1, $elo_2, $score)
{
	$k = valeur_k($elo_1);
	$estimation = estimation($elo_1, $elo_2);
	$nouveau_rang = $elo_1 + $k * ($score - $estimation);
 
	// On ne veut personne en dessous d'une cote elo de 300
	if ($nouveau_rang < 300)
	{
		$nouveau_rang = 300;
	}
 
	return array($nouveau_rang, $estimation);
}
 
// Calcule la valeur de K en fonction de la cote du joueur
function valeur_k($elo)
{
	if ($elo < 1000)
	{
		$k = 80;
	}
 
	if ($elo >= 1000 AND $elo < 2000)
	{
		$k = 50;
	}
 
	if ($elo >= 2000 AND $elo <= 2400)
	{
		$k = 30;
	}
 
	if ($elo > 2400)
	{
		$k = 20;
	}
 
	return $k;
}
 
 
function nouveau_rangs($elo_1, $elo_2, $score)
{
	// Score pour J2 VS J1
	$score_2 = 1 - $score;
 
	$calcul_J1 = calcul_elo($elo_1, $elo_2, $score);
	$estimation_J1 = $calcul_J1[1];
	$elo_J1 = round($calcul_J1[0]);
 
	$calcul_J2 = calcul_elo($elo_2, $elo_1, $score_2);
	$estimation_J2 = $calcul_J2[1];
	$elo_J2 = round($calcul_J2[0]);
 
	return array($elo_J1, $elo_J2, $estimation_J1, $estimation_J2);
}
 
function afficher_difference($nb)
{
	if ($nb >= 0)
	{
		$nb = '+'.$nb;
	}
 
	return $nb;
}
 
function convertir_pourcentage($nb)
{
	return round($nb * 100, 2).' %';
}
 
function phrase_score($score)
{
	if($score == 1)
	{
		return 'J1 gagne';
	}
 
	if ($score == 0)
	{
		return 'J2 gagne';
	}
 
	if ($score == 0.5)
	{
	return 'Match nul';
	}
}

/***************************************************************************************/ 
// Traitement des résultats

function traitement($tag_affiche, $elo1, $elo2, $score)
{
	$retour = nouveau_rangs($elo1, $elo2, $score);
	$elo_J1 = $retour[0];
	$elo_J2 = $retour[1];
	$estimation_J1 = $retour[2];
	$estimation_J2 = $retour[3];
 
	$difference_J1 = afficher_difference($elo_J1 - $elo1);
	$difference_J2 = afficher_difference($elo_J2 - $elo2);
 
	if($tag_affiche == true)
	{// Affichage + statistiques
		echo ' J1 : Probabilité de gagner : '  .convertir_pourcentage($estimation_J1);
		echo '<br/>';
		echo ' J2 : Probabilité de gagner : '  .convertir_pourcentage($estimation_J2);
		echo '<br/>';
	}
	
/*	echo '
	<h3>Si '.phrase_score($score).'</h3>
	J1 : '.$elo_J1.' (variation : '.$difference_J1.'). Probabilité de gagner : '.convertir_pourcentage($estimation_J1).'.<br>
	J2 : '.$elo_J2.' (variation : '.$difference_J2.'). Probabilité de gagner : '.convertir_pourcentage($estimation_J2).'.
	';*/
	
	echo '
			<h3>Si '.phrase_score($score).'</h3>
			J1 : '.$elo_J1.' (variation : '.$difference_J1.')'.'<br>
			J2 : '.$elo_J2.' (variation : '.$difference_J2.')'.'<br>
		';
}	
	
// cote initiale de J1
$elo1 = 1800; // 2300
// cote initiale de J2
$elo2 = 1600; // 1700
/*
// Score du match J1 contre J2
// 1 : P1 gagne
// 0 : P1 perd
// 0.5 : match nul
*/

echo '
	<h3>cote initiale</h3>
	J1 : '.$elo1.'<br>
	J2 : '.$elo2.'<br>
	';

echo "<br/>";
echo "----------------------------------------------------------";
echo "<br/>";
$score = 1;
traitement(true, $elo1, $elo2, $score);	
echo "<br/>";
echo "----------------------------------------------------------";
echo "<br/>";
$score = 0;
traitement(false, $elo1, $elo2, $score);	
echo "<br/>";
echo "----------------------------------------------------------";
echo "<br/>";
$score = 0.5;
traitement(false, $elo1, $elo2, $score);		
	